/* Version: 1.0.84 - June 29, 2022 09:41:46 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.nblib = factory());
})(this, (function () { 'use strict';

  var isBrowser = isBrowser || new Function("try {return this===window;}catch(e){ return false;}");
  var axios;
  const g_isBrowser = isBrowser();
  var _default = {
    API: null,
    adminAPI: null,
    APIagent: null,
    token: "",
    nbpayKey: "",
    opay: null,
    sendByNode: true,
    enable_write: false,
    debug: true
  };
  let g_config = null;
  let log = console.log;
  var blake3;
  var bsvLib, arLib;
  var CoinFly = null;
  const namecheckAPI = "https://util.nbsite.link/namecheck/v1/check/";
  let nodeInfo = {};
  let tld_config = {
    "test": {
      "testing": true,
      "chain": "bsv",
      "address": {
        "payment": "19fLpT5LpaMGKuLfUVqmNdXkVceq2rbjyn",
        "protocol": "1PuMeZswjsAM7DFHMSdmAGfQ8sGvEctiF5",
        "admin": "1KEjuiwj5LrUPCswJZDxfkZC8iKF4tLf9H",
        "other_admins": [{
          "address": "1PuMeZswjsAM7DFHMSdmAGfQ8sGvEctiF5",
          "start_block": 0,
          "end_block": 658652
        }]
      }
    },
    "b": {
      "testing": false,
      "chain": "bsv",
      "address": {
        "payment": "15Cww7izEdyr8QskJmqwC5ETqWREZCjwz4",
        "protocol": "14PML1XzZqs5JvJCGy2AJ2ZAQzTEbnC6sZ",
        "admin": "14PML1XzZqs5JvJCGy2AJ2ZAQzTEbnC6sZ",
        "other_admins": []
      }
    }
  };

  async function loadScript(url) {
    return new Promise(resolve => {
      var script = document.createElement("script");
      script.type = "text/javascript";

      script.onload = function () {
        resolve(true);
      };

      script.onerror = () => {
        console.error("error loading" + url);
        resolve(false);
      };

      script.src = url;
      document.getElementsByTagName("head")[0].appendChild(script);
    });
  }

  class nblib {
    static async init(option) {
      if (this.inited) return;
      g_config = { ..._default,
        ...option
      };
      if (g_config.debug == false) log = msg => {};

      if (g_config.API === null && navigator) {
        g_config.API = navigator.language.toLowerCase().slice(0, 2) === "zh" ? "https://nbnode.maxthon.com/api/" : "https://api.nbdomain.com/api/";
      }

      console.log('nblib: 1.0.84 - June 29, 2022 09:41:46');
      log("init:", g_config);
      nblib.setOpay(g_config.opay);

      try {
        await nblib._loadLibs();
        nodeInfo = await nblib.getNodeInfo();
        if (nodeInfo) tld_config = nodeInfo.tld;

        if (option.enable_write) {
          await nblib._loadWriteLibs(option.chain); //option.chain=['bsv','ar']
        }
      } catch (e) {
        log(e);
        throw "nblib Init failed:" + e;
      }

      this.inited = true;
    }
    /**
     * Set opay object to be used in webpage.
     * @param {object} - opay or opay2 object
     */


    static setOpay(opay) {
      g_config.opay = opay;
      opay && opay.setRelay(g_config.API);
    }

    static setAPI(option) {
      if (option.API) g_config.API = option.API;
      if (option.adminAPI) g_config.adminAPI = option.adminAPI;
    }

    static getCoinlib({
      domain,
      tld,
      chain
    }) {
      if (domain) {
        tld = domain.slice(domain.lastIndexOf('.') + 1);
      }

      if (tld) {
        chain = nodeInfo.tld[tld].chain;
      }

      switch (chain) {
        case 'bsv':
          return bsvLib;

        case 'ar':
          {
            if (!arLib) {
              throw 'arLib not initialized';
            }

            return arLib;
          }

        default:
          throw 'unsupported chain';
      }
    }
    /**
     * @param  {string} string to hash
     * @return {string} hashed string
     */


    static sha256(dataObj) {
      const bsv = bsvLib.bsv;
      let hash1 = bsv.crypto.Hash.sha256(bsv.deps.Buffer(dataObj)).toString('hex');
      return hash1;
    }

    static validate(domain) {
      domain = domain.toLowerCase();
      const [nid, ext] = domain.split(".");
      if (!ext) return false;
      const keys = Object.keys(tld_config);

      for (var i = keys.length - 1; i >= 0; i--) {
        if (keys[i] === ext) return true;
      }

      return false;
    }
    /**
     * @param  {string} root domain name
     * @return {object} domain object
     */


    static async getDomain(domain) {
      const res = await nblib.readDomain(domain);
      log("getting domain:" + domain + "\n", res);

      if (res && res.code == 0) {
        const inst = new nblib(domain, res);
        return inst;
      }

      log("failed getting domain. res=", res);
      return null;
    }

    static async getUser(account) {
      const dd = account.split('@');
      if (dd.length < 2) throw "account must includs @";
      const domain = dd[1];
      let res = await nblib.readDomain(domain);
      log("getting domain:" + domain + "\n", res);

      if (!res || res.code != 0) {
        console.error(domain + " doesn't exist or error");
        return null;
      }

      res = await nblib.readDomain(account);

      if (res.code != 0) {
        console.error("account doesn't exist");
        return null;
      }

      const inst = new nblib(domain, res);
      inst.info.owner_key = res.obj.publicKey;
      inst.isUser = true;
      return inst;
    }

    constructor(domain, res) {
      this.info = res.obj;
      [this.nid, this.tld] = domain.split('.');
      this.domain = domain;
      this.config = tld_config[this.tld].address;
      this.lastTXID = res.obj.last_txid;

      if (g_config.enable_write) ; //log(this);

    }
    /**
     * @param {string} privateKey to be used with nodeJS app
     */


    async setPrivateKey(privateKey) {
      if (!g_config.enable_write) {
        throw "to be able to send transactions, Please enable_write when call init(...)";
      }

      const lib = nblib.getCoinlib({
        domain: this.domain
      });
      this.pKey = privateKey;
      const pubKey = await lib.getPublicKey(privateKey);

      if (pubKey != this.info.owner_key) {
        throw "Not the owner of:" + this.nid + "." + this.tld;
      }
    }

    async updateUser({
      name,
      publicKey,
      chain,
      broadcast = true
    }) {
      if (this.isUser) throw "Not accessible for user account";
      const value = chain ? {
        name,
        publicKey,
        chain
      } : {
        name,
        publicKey
      };
      let cmd = ["user", "v1", JSON.stringify(value)];
      return await this._sendCommand({
        cmd,
        broadcast
      });
    }
    /**
     * Make a domain as public, so everyone can write to it. inreversible. 
     * @param  {string} domain to set as public
     * @return {json} result
     */


    async makePublic(confirm_domain) {
      if (this.isUser) throw "Not accessible for user account";

      if (confirm_domain != this.nid + '.' + this.tld) {
        throw "Wrong domain, please confirm";
      }
      let cmd = ["make_public"];
      return await this._sendCommand({
        cmd
      });
    }
    /**
     * Write contents to a public domain
     * @param  {object} option - option of the update
     * @param  {object} option.kv - key/value pairs. eg: for key {abc:{abc:"234"}} or {abc:{def:100}} or for keys ab and cd {ab:100,cd:200} 
     * @param  {string} option.tags - string. eg: for key {abc:{abc:"234"}} or {abc:{def:100}} or for keys ab and cd {ab:100,cd:200}  
     * @param  {Boolean} option.isUser - indicate it's for key.domain.tld or key@domain.tld
     * @param  {object[]} option.pay - object array. eg: [{address:"dfdaf"},value:1000}]. some chain, like ar, only supports one receiver per tx
     * @return {json} result of the update
     */


    async writePublicDomain({
      domain,
      kv,
      tags,
      pay
    }) {
      const res = await nblib.readDomain(domain);

      if (res.code != 0) {
        console.error("ERR:", domain, res);
        return;
      }

      if (res.obj.status != 16) {
        console.error("Not a Public domain:", domain);
        return;
      }

      kv.toDomain = domain;
      return await this.updateKey2({
        kv,
        tags,
        pay,
        isUser: false
      });
    }
    /**
     * @param  {object} option - option of the update
     * @param  {object} option.kv - key/value pairs. eg: for key {abc:{abc:"234"}} or {abc:{def:100}} or for keys ab and cd {ab:100,cd:200} 
     * @param  {string} option.tags - string. eg: for key {abc:{abc:"234"}} or {abc:{def:100}} or for keys ab and cd {ab:100,cd:200}  
     * @param  {Boolean} option.isUser - indicate it's for key.domain.tld or key@domain.tld
     * @param  {object[]} option.pay - object array. eg: [{address:"dfdaf"},value:1000}]. some chain, like ar, only supports one receiver per tx
     * @return {json} result of the update
     */


    async updateKey2({
      kv,
      tags = null,
      pay,
      broadcast = true
    }) {
      let cmd = ["key", JSON.stringify(kv)];
      if (tags) cmd = cmd.concat(JSON.stringify({
        tags: tags
      }));

      if (nodeInfo.payment && nodeInfo.prices && nodeInfo.prices.keyUpdate) {
        let size = JSON.stringify(cmd).length;
        if (size < 1000) size = 1000;
        const lib = nblib.getCoinlib({
          domain: this.domain
        });

        if (!lib) {
          return {
            code: 1,
            message: "unsupported chain"
          };
        }

        const fee = nodeInfo.prices.keyUpdate.fee;
        const address = tld_config[this.tld].address.payment;
        const address1 = nodeInfo.payment[lib.name];
        let amount = nodeInfo.prices.keyUpdate[lib.name] * size;
        let amount1 = 0;

        if (fee) {
          amount1 = Math.floor(amount * fee);
          amount = amount - amount1;
        }

        if (!pay) pay = [];
        pay.push({
          address: address,
          value: amount
        });
        if (amount1) pay.push({
          address: address1,
          value: amount1
        }); //console.log("size;",size,"pay:",pay)
      }

      return await this._sendCommand({
        cmd,
        more_to: pay,
        broadcast
      });
    }

    async updateKey(option) {
      return await this.updateKey2(option);
    }

    async transfer({
      owner
    }) {
      if (this.isUser) throw "Not accessible for user account";

      if (!owner) {
        return {
          code: -1,
          message: "owner information not set"
        };
      }

      try {
        const lib = nblib.getCoinlib({
          domain: this.domain
        });
        let cmd = ["transfer", owner];
        return await this._sendCommand({
          cmd
        });
        const owner_pubKey = owner; //    const addr = await lib.getAddress(owner_pubKey); //bsLib.PublicKey.fromHex(owner_pubKey).toAddress().toString();
        //     const more_to = [{
        //         address:this.config.payment,value:1000
        //     }]

        const sendOption = {
          protocol: this.config.protocol,
          nid: this.nid,
          key: g_config.opay ? this.info.owner_key : this.pKey,
          cmd: cmd,
          lastTXID: this.lastTXID,
          more_to: more_to,
          broadcast: true,
          coinlib: lib
        };
        const ret = await nblib._baseSendCommand(sendOption);
        return ret;
      } catch (e) {
        console.error(e);
        return {
          code: -1,
          message: e.message
        };
      }

      return {
        code: -2,
        message: "shall not be here"
      };
    }

    async sell({
      buyer,
      price,
      expire,
      clear_data,
      note
    }) {
      if (this.isUser) throw "Not accessible for user account";

      if (!buyer || !price || !expire) {
        throw "must have buyer, price and expire";
      }

      let op = {
        buyer: buyer,
        price: price,
        expire: expire,
        clear_data: clear_data,
        note: note
      };

      if (op.buyer !== "any") {
        //domain
        const info = await nblib.readDomain(op.buyer);
        log("buyer info:", info);

        if (info.code == 0) {
          op.buyer = info.obj.owner;
        } else {
          return {
            code: 1,
            message: "no valid buyer, must be NBdomain"
          };
        }
      }

      let cmd = ["sell", JSON.stringify(op)];
      console.log(cmd);
      return await this._sendCommand({
        cmd
      });
    }

    static _configFromProtocol(protocol) {
      const keys = Object.keys(tld_config);

      for (var i = keys.length - 1; i >= 0; i--) {
        const config = tld_config[keys[i]];
        if (config.address.protocol === protocol) return config;
      }

      return null;
    }

    async _sendCommand({
      cmd,
      more_to = null,
      broadcast = true
    }) {
      if (!this.pKey && g_config.opay == null) {
        throw "please setPayment first";
      }

      const lib = nblib.getCoinlib({
        domain: this.domain
      });
      const sendOption = {
        protocol: this.config.protocol,
        nid: this.nid,
        key: g_config.opay ? this.info.owner_key : this.pKey,
        cmd: cmd,
        more_to: more_to,
        lastTXID: this.lastTXID,
        broadcast: broadcast,
        coinlib: lib
      }; //console.log(sendOption);

      const ret = await nblib._baseSendCommand(sendOption);
      return ret;
    }
    /**
     * @param  {string} data_hash - hasded string of data
     * @param  {string} strSig - signature
     * @return {bool} result of verify
     */


    async verifySig(data_hash, strSig) {
      if (!g_config.enable_write) {
        throw "to be able to send transactions, Please enable_write when call init(...)";
      }

      const lib = nblib.getCoinlib({
        domain: this.domain
      });
      return lib.verify(this.info.owner_key, data_hash, strSig); //let sig = bsLib.crypto.Signature.fromString(strSig);
      //let pubKey = bsLib.PublicKey.fromString(this.info.owner_key);
      //let hash2 = bsLib.crypto.Hash.sha256(bsLib.deps.Buffer.from(data_hash,'hex'));
      //return bsLib.crypto.ECDSA.verify(hash2,sig,pubKey);
    }

    async readKey(key) {
      return await nblib.readDomain(key + '.' + this.domain);
    }

    async readUser(user) {
      return await nblib.readDomain(key + '@' + this.domain);
    }

    async isOwner(address) {
      return this.info.owner == address;
    }
    /**
     * @param  {object} option - 
     * @param  {domain} option.domain - domain to buy
     * @return {json} result
     */


    async buy(option) {
      if (this.isUser) throw "Not accessible for user account";
      if (!option.domain) throw "option.domain is missing";
      const {
        domain,
        note
      } = option;
      let key = {};

      if (g_config.opay) {
        key.publicKey = this.info.owner_key;
      } else {
        key.privateKey = this.pKey;
      }

      const lib = nblib.getCoinlib({
        domain: domain
      });
      const res = await nblib.readDomain(domain);
      log("domain is", domain, " res:", res);

      if (res.code != 0) {
        return {
          code: 1,
          message: "Domain is not registered"
        };
      }

      if (!res.obj.sell_info) {
        return {
          code: 2,
          message: "Domain is not on sale"
        };
      }

      const {
        buyer,
        price,
        expire,
        sell_txid
      } = res.obj.sell_info;
      const privKey = key.privateKey;
      const pubKey = key.publicKey;
      const dom = domain.split('.');
      const config = tld_config[dom[1]].address;
      const rExpire = new Date(expire);

      if (Date.now() > rExpire) {
        return {
          code: 3,
          message: "Sell Expired"
        };
      }

      if (buyer != "any") {
        let address = null;

        if (privKey) {
          const pKey = await lib.getPublicKey(privKey);
          address = await lib.getAddress(pKey);
        }

        if (pubKey) address = await lib.getAddress(pubKey);

        if (address != buyer) {
          log("address:", address, " buyer:", buyer);
          return {
            code: 4,
            message: "Incorrect Buyer"
          };
        }
      }

      const pay1 = price;
      let pay2 = price * (nodeInfo.prices.sellFee ? nodeInfo.prices.sellFee : 0.1);
      if (pay2 < 600) pay2 = 600;
      const refer = option.refer ? option.refer : "none";
      const cmd = ['buy', 'v2', JSON.stringify({
        domain: domain,
        sell_txid: sell_txid,
        note: note
      }), refer];
      const more_to = [{
        address: res.obj.owner,
        value: pay1
      }, {
        address: config.payment,
        value: pay2
      }];
      const sendOption = {
        protocol: this.config.protocol,
        nid: this.nid,
        key: g_config.opay ? this.info.owner_key : this.pKey,
        cmd: cmd,
        more_to: more_to,
        coinlib: lib
      };
      const ret = await nblib._baseSendCommand(sendOption);
      return ret;
    }

    static async _loadLibs() {
      if (!g_isBrowser) {
        axios = require('axios');
      } else {
        if (!window.axios) await loadScript("https://unpkg.com/axios/dist/axios.min.js");
        axios = window.axios;
      }
    }

    static async _loadWriteLibs(chains) {
      if (!chains) chains = ['bsv', 'ar'];

      if (g_isBrowser) {
        await loadScript("https://unpkg.com/hash-wasm@4.9.0/dist/blake3.umd.min.js");
        blake3 = hashwasm.blake3;
        await loadScript("https://unpkg.com/coinfly@latest/dist/coinfly.min.js");
        CoinFly = window.coinfly;
      } else {
        CoinFly = require('coinfly');
        blake3 = require('hash-wasm').blake3;
      }

      for (const chain of chains) {
        if (chain == 'bsv') bsvLib = await CoinFly.create('bsv', {
          nbAPI: g_config.API
        });
        if (chain == 'ar') arLib = await CoinFly.create('ar', {
          nbAPI: g_config.API
        });
      }
    }

    static async getRate(symbol) {
      return await this._invokeAPI("tools/market/rates/" + symbol);
    }

    static async updateAPI() {
      if (g_config.APIagent) {
        const res = await axios.get(g_config.APIagent);

        if (res.data) {
          if (res.data.API && g_config.API != res.data.API) {
            g_config.API = res.data.API;
            if (g_config.opay) g_config.opay.setRelay(g_config.API);
            nodeInfo = await nblib.getNodeInfo();
          }

          if (res.data.adminAPI) g_config.adminAPI = res.data.adminAPI;
        }
      }
    }

    static async sendTXByNode(data) {
      log("------------------------sendTXByNode---------------------: ");
      log("data:", data);
      await nblib.updateAPI();
      const url = g_config.API + "sendtx";
      const options = {
        method: "POST",
        headers: {
          'content-type': 'application/json;charset=UTF-8'
        },
        mode: "cors"
      };

      try {
        let res = await axios.post(url, JSON.stringify({
          rawtx: data.rawtx,
          more_rawtx: data.more_rawtx,
          chain: data.chain,
          oData: data.more_data
        }), options);
        let json = res.data;
        log("sendTXByNode result:", json);
        return json;
      } catch (e) {
        return {
          code: 1,
          message: e.message
        };
      }
    }

    static _toArOption(option, cmd) {
      console.log(option, cmd);
      let data = option.data ? option.data.slice(0, 4) : option.pay.to[0].data.slice(0, 4);

      if (option && option.pay && option.pay.to) {
        const tos = option.pay.to.filter(item => Object.keys(item)[0] === 'address');
        option.pay.to = tos;
      }

      let tags = {
        nbprotocol: 'nbd',
        nbdata: JSON.stringify(data)
      }; //let cmds = JSON.stringify(cmd)

      option.tags = tags;
      option.data = "nb";
      /*if(cmds.length<1024){
          option.tags.cmd = cmds
          option.data="nb"
      }else{
          option.data = cmds
      } */

      return option;
    }

    static async _opay_baseSendCommand({
      protocol,
      nid,
      key,
      cmd,
      last_txid,
      more_to = null,
      broadcast = true,
      coinlib
    }) {
      if (!g_config.enable_write) {
        throw "to be able to send transactions, Please enable_write when call init(...)";
      }

      const lib = coinlib;
      const pubKey = key;
      const address = pubKey ? await lib.getAddress(pubKey) : null;
      const timestamp = Math.floor(Date.now() / 1000);
      cmd = [protocol, nid].concat(cmd);
      const cmds = JSON.stringify(cmd);
      let hash = await blake3(cmds, 128);
      return new Promise(resolve => {
        //const address = pubKey ? bsLib.PublicKey.fromHex(pubKey).toAddress().toString() : null;
        const orgBroadcast = broadcast;
        if (g_config.sendByNode) broadcast = false; //send tx via node, not wallet

        let nbd_json = {
          v: 3,
          ts: '{{timestamp}}',
          hash: hash
        };
        const nbd_attribute = JSON.stringify(nbd_json);
        let reqBody = {
          app: {
            name: "NBdomain"
          },
          more_data: cmds,
          data: ['nbd', nbd_attribute],
          to: [{
            protocol: "bitIdentity"
          }],
          broadcast: broadcast,
          chain: lib.name
        };

        if (pubKey) {
          reqBody.payer = address;
          reqBody.to[0].value = {
            public_key: pubKey
          };
        } //reqBody.data = reqBody.data.concat(cmd);


        if (more_to) {
          reqBody.to = reqBody.to.concat(more_to);
        }

        if (lib.name == 'ar') {
          reqBody = nblib._toArOption(reqBody, cmd);
        }

        g_config.opay.pay(reqBody, async ret => {
          ret.chain = lib.name;

          if (orgBroadcast && g_config.sendByNode) {
            if (ret.code == 0) {
              ret = await nblib.sendTXByNode(ret);
              if (ret) ret.ts = timestamp;
            }
          }

          resolve(ret);

          if (ret.usedWallet) {
            opay.setWallet(ret.usedWallet);
          }

          if (broadcast == false) return false;
          return {
            code: 0,
            id: ret.id,
            message: "ok"
          };
        });
      });
    }

    static async _baseSendCommand(sendOption) {
      if (!g_config.enable_write) {
        throw "to be able to send transactions, Please enable_write when call init(...)";
      }

      let {
        protocol,
        nid,
        key,
        cmd,
        last_txid,
        more_to,
        broadcast,
        coinlib
      } = sendOption;
      if (g_config.opay && !sendOption.forcePrivKey) return nblib._opay_baseSendCommand(sendOption);
      if (broadcast != false) broadcast = true;
      const lib = coinlib ? coinlib : bsvLib;
      const privKey = key;
      const timestamp = Math.floor(Date.now() / 1000);
      cmd = [protocol, nid].concat(cmd);
      const cmds = JSON.stringify(cmd);
      let hash = await blake3(cmds, 128);
      let nbd_json = {
        v: 3,
        ts: '{{timestamp}}',
        hash: hash
      };
      const nbd_attribute = JSON.stringify(nbd_json);
      return new Promise(async resolve => {
        let config = {
          data: ['nbd', nbd_attribute],
          more_data: cmds,
          pay: {
            key: privKey,
            feeb: 0.5,
            to: [{
              protocol: "bitIdentity",
              value: {
                privateKey: privKey
              }
            }]
          }
        }; //config.data = config.data.concat(cmd);

        if (more_to) {
          config.pay.to = config.pay.to.concat(more_to);
        }

        let data = {};
        let res = null;

        if (lib.name == 'bsv') {
          log("before gentx:", JSON.stringify(config));
          res = await lib.build(config);
          data = res;
        }

        if (lib.name == 'ar') {
          config = nblib._toArOption(config, cmd);
          res = await lib.build(config);
          if (res.code == 0) data = res;
        }

        if (data.rawtx) {
          data.chain = lib.name;

          if (!broadcast) {
            resolve({
              code: 0,
              ...data
            });
            return;
          }

          if (g_config.sendByNode) {
            let ret = await nblib.sendTXByNode(data);
            if (ret) ret.ts = timestamp;
            resolve(ret);
            return;
          }

          let res = await lib.send({
            rawtx: data.rawtx,
            more_rawtx: data.more_rawtx
          });
          if (res) res.ts = timestamp;
          resolve(res);
        } else {
          resolve(res);
        }
      });
    }

    static isValidAdmin(tld, address) {
      const all = tld_config[tld].address;
      if (address == all.admin) return true;
      return all.other_admins.includs(address);
    }

    static async registerDomain(domain, option) {
      if (!g_config.enable_write) {
        throw "to be able to send transactions, Please enable_write when call init(...)";
      }

      const lib = nblib.getCoinlib({
        domain
      });
      const dom = domain.split('.');
      const config = tld_config[dom[1]].address;

      try {
        const res = await nblib.getPrice(domain);

        if (res.code == 0) {
          return {
            code: 1,
            message: "Domain is registered"
          };
        }

        if (!res.price) {
          return {
            code: 2,
            message: "Domain is reserved"
          };
        }

        await axios.get(namecheckAPI + encodeURIComponent(domain) + "?prereg=check");
        const cmd = ['register', 'v2'];
        const more_to = [{
          address: config.payment,
          value: res.price
        }];
        let attrib = {};
        if (option && option.toKey) attrib.toKey = option.toKey;
        if (option && option.refer) attrib.refer = option.refer;
        if (attrib != {}) cmd.push(JSON.stringify(attrib));
        const sendOption = {
          protocol: config.protocol,
          nid: dom[0],
          key: g_config.opay ? option?.publicKey : option.privateKey,
          cmd: cmd,
          more_to: more_to,
          coinlib: lib
        };
        const ret = await nblib._baseSendCommand(sendOption);
        return ret;
      } catch (e) {
        log(e);
        return {
          code: 100,
          message: e.message
        };
      }
    }

    static async _InvokeRawCMD(data, chain = 'bsv') {
      if (!g_config.enable_write) {
        throw "to be able to send transactions, Please enable_write when call init(...)";
      }

      await nblib.updateAPI();
      const url = g_config.adminAPI ? g_config.adminAPI + "raw_cmd" : g_config.API + "raw_cmd";
      const options = {
        method: "POST",
        headers: {
          'content-type': 'application/json;charset=UTF-8',
          'Authorization': 'Bearer ' + g_config.token
        },
        mode: "cors"
      };

      try {
        let res = await axios.post(url, JSON.stringify({
          rawtx: data.rawtx,
          oData: data.more_data,
          chain: chain
        }), options);
        let json = res.data;
        log("raw cmd result:", json);
        return {
          code: json.code,
          txid: json.txid,
          message: json.message
        };
      } catch (e) {
        return {
          code: 1,
          message: e.message
        };
      }
    }

    static async _buildRegTX(domain, option) {
      if (!g_config.enable_write) {
        throw "to be able to send transactions, Please enable_write when call init(...)";
      }

      const lib = nblib.getCoinlib({
        domain
      });
      const dom = domain.split('.');
      const config = tld_config[dom[1]].address;

      try {
        const res = await nblib.readDomain(domain);

        if (res.code == 0) {
          return {
            code: 1,
            message: "Domain is registered"
          };
        }

        if (!res.price) {
          return {
            code: 2,
            message: "Domain is reserved"
          };
        } //const objKey = bsLib.PrivateKey.fromWIF(option.privKey);
        //const pubKey = bsLib.PublicKey.fromPrivateKey(objKey);
        //const refer = option.refer ? option.refer : "none";


        const cmd = ['pay_register']; //,pubKey.toHex(),refer];

        const more_to = [{
          address: config.payment,
          value: res.price
        }];
        let pubKey = null;

        if (option) {
          if (option.privateKey) {
            pubKey = await lib.getPublicKey(option.privateKey);
          }
        }

        if (option && option.publicKey) pubKey = option.publicKey;
        if (pubKey) cmd.push(pubKey);
        if (option && option.refer) cmd.push(option.refer);
        const sendOption = {
          protocol: config.payment,
          nid: dom[0],
          key: g_config.opay ? pubKey : option.privateKey,
          cmd: cmd,
          more_to: more_to,
          broadcast: false,
          coinlib: lib
        };
        const ret = await nblib._baseSendCommand(sendOption); //const ret = await nblib._baseSendCommand(config.payment,dom[0],option.privKey,cmd,null,null,more_to,false);

        return ret;
      } catch (e) {
        log(e);
        return {
          code: 100,
          message: e.message
        };
      }
    }

    static async _buildBuyTX(option, key) {
      if (!g_config.enable_write) {
        throw "to send transactions, Please enable_write when call init(...)";
      }

      const domain = option.domain;
      const note = option.note;
      const privKey = key.privateKey;
      const pubKey = key.publicKey;
      const dom = domain.split('.');
      const config = tld_config[dom[1]].address;
      const lib = nblib.getCoinlib({
        domain
      });

      try {
        const res = await nblib.readDomain(domain);
        log("domain is", domain, " res:", res);

        if (res.code != 0) {
          return {
            code: 1,
            message: "Domain is not registered"
          };
        }

        if (res.obj.sell_info == null) {
          return {
            code: 2,
            message: "Domain is not on sale"
          };
        }

        const {
          buyer,
          price,
          expire,
          sell_txid
        } = res.obj.sell_info;
        const rExpire = new Date(expire);

        if (Date.now() > rExpire) {
          return {
            code: 3,
            message: "Sell Expired"
          };
        }

        if (buyer != "any") {
          let address = null;

          if (privKey) {
            const pKey = await lib.getPublicKey(privKey);
            address = await lib.getAddress(pKey); //address = bsLib.PrivateKey.fromWIF(privKey).toAddress().toString();
          }

          if (pubKey) address = await lib.getAddress(pubKey); //bsLib.PublicKey(pubKey).toAddress().toString();

          if (address != buyer) {
            log("address:", address, " buyer:", buyer);
            return {
              code: 4,
              message: "Incorrect Buyer"
            };
          }
        }

        const pay1 = price * 0.9;
        let pay2 = price * 0.1;
        if (pay2 < 600) pay2 = 600;
        const refer = option.refer ? option.refer : "none";
        const cmd = ['pay_buy', JSON.stringify({
          sell_txid: sell_txid,
          note: note
        }), refer];
        const more_to = [{
          address: res.obj.owner,
          value: pay1
        }, {
          address: config.payment,
          value: pay2
        }];
        const sendOption = {
          protocol: config.payment,
          nid: dom[0],
          key: g_config.opay ? pubKey : privKey,
          cmd: cmd,
          more_to: more_to,
          broadcast: false,
          coinlib: lib
        };
        const ret = await nblib._baseSendCommand(sendOption);
        return ret;
        /* if(g_config.opay){
            const ret = await nblib._opay_baseSendCommand(config.payment,dom[0],pubKey,cmd,null,null,more_to,false);
            return ret;
        }else{
            const ret = await nblib._baseSendCommand(config.payment,dom[0],privKey,cmd,null,null,more_to,false);
            return ret;
        }*/
      } catch (e) {
        log(e);
        return {
          code: 100,
          message: e.message
        };
      }
    }

    static async _invokeAPI(para) {
      await nblib.updateAPI();
      const url = g_config.API + para;
      const myInit = {
        method: 'GET',
        headers: {
          'content-type': 'application/json;charset=UTF-8',
          'Authorization': 'Bearer ' + g_config.token
        },
        mode: 'cors',
        cache: 'default'
      };

      try {
        const url1 = encodeURI(url);
        const res = await axios.get(url1, myInit);

        if (res) {
          return res.data;
        }
      } catch (e) {
        log(e);
      }

      return null;
    }
    /**
     * @return {json} nodeInfo from node
     */


    static async getNodeInfo() {
      let ret = await nblib._invokeAPI("nodeInfo");
      return ret;
    }

    static async getTLDinfo() {
      return await nblib._invokeAPI("tld");
    }
    /**
     * @param  {string} domain - one or more domains, separated by ',' .eg "test.b" "test.b,www.abc.b" "aaa.test886.test/all,aaa.test886.test/1"
     * @param  {Boolean}
     * @return {json}
     */


    static async queryDomain(domain, full = false, price = true) {
      const para = full ? "/qf/" + domain + "?price=" + (price ? "true" : "false") : "/q/" + domain + "?price=" + (price ? "true" : "false");
      const res = await nblib._invokeAPI(para);
      return res;
    }

    static async getOnSale() {
      const para = "onSale";
      const res = await nblib._invokeAPI(para);
      return res;
    }

    static async readDomain(domain, full = false, price = false) {
      const para = "?nid=" + domain + "&full=" + (full ? "true" : "false") + "&price=" + (price ? "true" : "false");
      const res = await nblib._invokeAPI(para);
      if (res && res.obj && res.obj.owner_key) res.obj.owner_key = res.obj.owner_key;
      return res;
    }

    static async getPrice(domain) {
      let res = await nblib.queryDomain(domain, false, true);
      if (res && res.length == 1) res = res[0];
      return res;
    }

    static async readUser(account) {
      const para = "/user/" + account;
      const res = await nblib._invokeAPI(para);
      return res;
    }
    /**
     * @param  {string} address - address of the domains
     * @return {json} result
     */


    static async domainFromAddress(address) {
      return await nblib._invokeAPI("findDomain?address=" + address);
    }
    /**
     * findDomain according to the option
     * 
     * @param  {string} option.address [owner address]
     * @param  {object} option.time{from:,to:} [register time]
     * @return {[type]}        [description]
     */


    static async findDomain(option) {
      return await nblib._invokeAPI("findDomain?option=" + JSON.stringify(option));
    }

  }
  if (g_isBrowser == false) module.exports = nblib;

  return nblib;

}));
